package bluetooth;

//import java.util.Vector;
import java.io.*; 

import javax.microedition.io.*; 

public class NWTCP
{
	private static String ServerAddress = "socket://google.de:80";
	private SocketConnection TCPSocket = null;
	private DataInputStream TCPStreamIn = null;
	private DataOutputStream TCPStreamOut = null;
	
	private boolean Connected=false;
	
	public NWTCP()
	{
		
	}
	
	// connect to server
	public int Connect()
	{
		try
		{
			TCPSocket = (SocketConnection) Connector.open(ServerAddress, Connector.READ_WRITE);
			TCPStreamOut = TCPSocket.openDataOutputStream();
			//TCPStreamIn = new DataInputStream(TCPSocket.openInputStream());
			TCPStreamIn = TCPSocket.openDataInputStream();
		}
		catch(ConnectionNotFoundException Error)
		{
			return 0;
		}
		catch(IOException Error)
		{
			return 0;
		}
		if(TCPStreamIn==null)
			return 0;
		Connected=true;
		return 1;
	}
	
	public int Disconnect()
	{
		Connected=false;
		try
		{
			TCPStreamIn.close();
			TCPStreamOut.close();
			TCPSocket.close();
		}
		catch(IOException Error)
		{
			return 0;
		}
		return 1;
	}
	
	public int Reconnect()
	{
		Disconnect();
		return Connect();
	}
	
	// available
	public int Available()
	{
		if(!Connected)
			return 0;
		int BufferSize=0;
		try
		{
			BufferSize=TCPStreamIn.available();
		}
		catch(IOException Error)
		{
			BufferSize=-1;
		}
		return BufferSize;
	}
	
	// send data
	public int SendData(byte[] Data, int Size)
	{
		try
		{
			TCPStreamOut.write(Data, 0, Size);
		}
		catch(IOException Error)
		{
			return 0;
		}
		return 1;
	}
	
	// receive data
	public int GetData(byte[] Data)
	{
		int ByteRead;
		try
		{
			ByteRead=TCPStreamIn.available();
			if(ByteRead==0)
				return 0;
			if(ByteRead>Data.length)
				ByteRead=Data.length;
			TCPStreamIn.read(Data, 0, ByteRead);
		}
		catch (IOException Error)
		{
			return -1;
		}
		return ByteRead;
	}
}
